#include "cart.hh"
#include <stdexcept>

void Cart::add_product(const Product *product) {
  _products.push_back(product);
}

void Cart::remove_product(const Product *product) {
  Products::iterator i = 
    std::find(_products.begin(), _products.end(), product);
  if(i == _products.end())
    throw std::runtime_error("Product \""
			     + (*i 
				? (*i)->name
				: std::string("null"))
			     + "\" is not inside cart.");
  _products.erase(i);
}
