#include "command.hh"

namespace {
  /// This is just used as a marker object.
  struct Mark: public Command {
    void execute() {}
    void unexecute() {}
  };
  Mark _the_mark;
  Mark* the_mark = &_the_mark;
}



CommandHistory* CommandHistory::_instance = 0;

CommandHistory& CommandHistory::instance() {
  if(!_instance)
    _instance = new CommandHistory();
  return *_instance;
}

void CommandHistory::push_command(Command *command, bool mark) {
  if(mark)
    this->mark();
  _commands.push_back(command);
}

void CommandHistory::mark() {
  _commands.push_back(the_mark);
}

void CommandHistory::undo() {
  // pop trailing marks first (non-unexecutable commands might add them)
  while(!_commands.empty() && _commands.back() == the_mark)
    _commands.pop_back();
  while(!_commands.empty()) {
    Command *command = _commands.back();
    command->unexecute();
    _commands.pop_back();
    if(command == the_mark)
      return;
  }
}

void CommandHistory::clear() { _commands.clear(); }
