#ifndef COMMAND_HH
#define COMMAND_HH
#include <vector>

struct Command {
  virtual void execute() = 0;
  virtual void unexecute() = 0;
  virtual ~Command() {}
};

/// This is a singleton.
class CommandHistory {
public:
  static CommandHistory& instance();
  void push_command(Command*, bool mark = true);
  void mark();
  void undo();
  void clear();

private:
  static CommandHistory* _instance;
  typedef std::vector<Command*> Commands;
  Commands _commands;
};

#endif
