#include "parser.hh"
#include "interpreter.hh"
#include "customer.hh"
#include "command.hh"

using namespace std;

namespace {
  void prompt() {
    cout << "> " << flush;
  }
}

int main() {
  string line;
  cout << "What is your name?" << endl;
  prompt();
  getline(cin, line);
  Customer customer(line);
  cout << "Hello " << customer.name << "!" << endl;
  //  customer.look();
  prompt();
  while(getline(cin, line)) {
    try {
      SyntaxTree *tree = parse(line);
      // marks should be set in the user interface because that is
      // what makes sens to the user
      CommandHistory::instance().mark();
      if(tree)
	tree->interpret(customer);
    }
    catch(const std::runtime_error &e) {
      cout << e.what() << endl;
    }
    //customer.look();
    prompt();
  }
}
