#ifndef PRODUCT_HH
#define PRODUCT_HH

#include <string>
#include <vector>
#include <iostream>

typedef int ID;

class Shop;

struct Price {
  Price(int d = 0, int c = 0) :_cent(c + 100 * d) {}
  Price& operator += (const Price& other) {
    _cent += other._cent;
    return *this;
  }
  long dollars() const { return _cent / 100; }
  long cent() const { return _cent % 100; }

private:
  long _cent;
};

std::ostream& operator << (std::ostream& out, const Price& price);

struct Product {
  Product(const Shop& shop, const std::string& n, 
	  Price p) 
    : name(n), price(p) 
  {}
  std::string name;
  ID id, shop_ID;
  Price price;
};

typedef std::vector<const Product*> Products;

#endif
