#include "world.hh"
//#include "shop.hh"
#include "mall.hh"
#include "cart.hh"
//#include "customer.hh"
#include <stdexcept>

class Drugstore: public Shop {
public:
  Drugstore(const std::string& name, Shop* parent = 0)
    : Shop(name, parent) 
  {
    _products.push_back(new Product(*this, "Strychnine", Price(42)));
    _products.push_back(new Product(*this, "Cyanide", Price(39, 99)));
  }
  virtual Shop* clone(const std::string& name, Shop* parent = 0) const {
    return new Drugstore(name, parent);
  }
  void put_in_cart(Cart &cart, const Product *product) {
    cart.add_product(product);
  }
  void remove_from_cart(Cart &cart, const Product *product) {
    cart.remove_product(product);
  }
  void add_shop(Shop *shop) {
    throw std::runtime_error("You can't build shops in a Drugstore!");
  }
};

World* World::_instance = 0;

World::World() {
  _shop_types["drugstore"] = new Drugstore("noname");
}

World& World::instance() {
  if(!_instance)
    _instance = new World();
  return *_instance;
}

void World::add_mall(Mall *mall) { _malls.push_back(mall); }

void World::remove_mall(Mall *mall) {
  Malls::iterator i = std::find(_malls.begin(), _malls.end(), mall);
  if(i != _malls.end())
    _malls.erase(i);
}

Malls World::malls() const { return _malls; }

const ShopTypes& World::shop_types() const { return _shop_types; }
