#ifndef WORLD_HH
#define WORLD_HH

#include <vector>
#include <map>
#include <string>

class Mall;
class Shop;

typedef std::vector<Mall*> Malls;
typedef std::map<std::string, Shop*> ShopTypes;

/** This is a singleton */
class World {
public:
  static World& instance();
  void add_mall(Mall*);
  void remove_mall(Mall*);

  /// Get a list of all malls  
  Malls malls() const;  

  const ShopTypes& shop_types() const;

private:
  static World *_instance;
  Malls _malls;
  ShopTypes _shop_types;

  World();
};

#endif
